#include "GTitleScene.h"

#include "../game/GStaticData.h"

#include "../player/GPlayerManager.h"


GTitleScene::GTitleScene(){
}

GTitleScene::~GTitleScene(){
}
void GTitleScene::init(){
	GPlayer* player = staticData->getObjectManager()->getPlayer();
	player->setHPMax(100);
	player->setHP(player->getHPMax());

}

void GTitleScene::quit(){
}

void GTitleScene::process(){
	staticData->clearScreen(0,10,0);
	// draw blocks
//	staticData->getBlockManager()->draw(staticData->getImageManager(),
//		staticData->getGraphics()->getScreen(),
//		staticData->getScrollManager()->getScroller(0));
		
	HPLRect gameRange = staticData->getGameRange();

	int tileSize = staticData->getSetting()->tileSize;

	float TILE_TOP = 288;
	HPLSequence* seq = staticData->getSequence(GEnum::SpriteType::Common,
		GEnum::Common::Title);
	seq->getImageInformation(0)->srcRect.set(64,0,32,32);
	for(int y = 0; y < 6; y ++){
		for(int i = 0; i < gameRange.getWidth() / tileSize; i ++){
		
			float left = i * tileSize;
			float top = y * tileSize + TILE_TOP;

			float rotate = 0;
			int alpha = 255;
			HPLSDLImageTool::blitRotozoomSpriteLeftTop(
				left, top,
				rotate,
				seq,
				staticData->getImageManager(),
				staticData->getGraphics()->getScreen(),
				alpha);
		}
	}

	bool isMove = staticData->getGame()->isTheWorld() == false &&
		staticData->getGame()->isMenu() == false &&
		staticData->getGame()->isScenario() == false;
/*

	/////////////////////////////
	// IuWFNgȂ񂽂
	staticData->getObjectManager()->update();
*/
//	staticData->getObjectManager()->getNeutralManager()->process(isMove);

	GPlayer* player = staticData->getObjectManager()->getPlayer();
//	GPlayer* aibo = staticData->getObjectManager()->getPlayer()->aibo;

	// drawplayer
	player->draw(staticData->getImageManager());
//	aibo->draw(staticData->getImageManager());

	
	if(isMove){
		// collision check
		GPlayerManager playerManager;
		// fall and hit to collision
		/*
		HPLVector velocityAngle = player->getVelocityAngle();
		HPLVector center = player->getCenter();
		playerManager.collisionCheck(
			staticData->getObjectManager()->getPlayer(),
			&center, &velocityAngle);
			*/

		if(player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND)){
			float resist = staticData->getSetting()->resist;
			float x = HPLActionMoveTool::reduceSpeed(resist, player->getVelocityAngle().getX());
			float y = HPLActionMoveTool::reduceSpeed(resist, player->getVelocityAngle().getY());
			player->setVelocityAngle(x,y);
		}

		//center.add(velocityAngle);
		//player->setCenter(center);
		//player->setVelocityAngle(velocityAngle);
		
		//velocityAngle = aibo->getVelocityAngle();
		//center = aibo->getCenter();
		//playerManager.collisionCheck(
		//	staticData->getObjectManager()->getPlayer()->aibo,
		//	&center, &velocityAngle);
		//center.add(velocityAngle);
		//aibo->setCenter(center);
		//aibo->setVelocityAngle(velocityAngle);

		player->getTrigger()->setTrigger(TriggerType::ON_THE_GROUND, true);
		// input moving
		HPLVector velocityAngle = player->getVelocityAngle();
		playerManager.move(
			player, &velocityAngle);
		HPLVector center = player->getCenter();
		if(player->getTrigger()->getTrigger(TriggerType::ON_THE_GROUND)){
			center.setY(player->groundY);
			velocityAngle.setY(0);
		}
		player->setVelocityAngle(velocityAngle);
		center.add(velocityAngle);
		player->setCenter(center);
		//velocityAngle = aibo->getVelocityAngle();
		//playerManager.move(
		//	aibo, &velocityAngle);
		//aibo->setVelocityAngle(velocityAngle);

		//////
		// attack
		//velocityAngle = player->getVelocityAngle();
		//center = player->getCenter();
		//playerManager.attack(
		//	player, &center, &velocityAngle);
		//center.add(velocityAngle);
		//player->setCenter(center);
		//player->setVelocityAngle(velocityAngle);

		//velocityAngle = aibo->getVelocityAngle();
		//center = aibo->getCenter();
		//playerManager.attack(
		//	aibo, &center, &velocityAngle);
		////center.add(velocityAngle);
		//aibo->setCenter(center);
		//aibo->setVelocityAngle(velocityAngle);
	}
/*	// draw and move enemy
	bool isMove = true;
*/

	///
	// enemy
	staticData->getObjectManager()->getEnemyManager()->process(isMove);
/*	// item
	staticData->getObjectManager()->getItemManager()->process(isMove);


	// shot
	staticData->getObjectManager()->getShotManager()->process(isMove);


	staticData->getObjectManager()->getEffectManager()->process(isMove);

/*
	// draw front blocks(tiles)
*/





	////////
	// adjust scroll
	{
		HPLScroller* scroller = staticData->getScrollManager()->getScroller(0);

		HPLVector scrPoint(
			staticData->getSetting()->windowWidth / 2.f,
			staticData->getSetting()->windowHeight / 2.f);

		bool isAdjust = true;

		// tag
		scroller->matchPoint(
			scrPoint, staticData->getObjectManager()->getPlayer()->getCenter(),
			isAdjust);
	}


	HPLSDLKanjiManager* sdlkanji = staticData->getSDLKanjiManager();
	{
		//////
		// L[
		int fontID = 0;
		int r = 255, g = 255, b = 0;
		
		float left = 300;
		float top = 50;
		float INTERVAL_Y = 20;

		sdlkanji->drawString(staticData->getGraphics()->getScreen(),
			left, top, fontID, r,g,b,
			"L[");
			top += INTERVAL_Y;
		
		std::list<std::string> lst;
		lst.push_back(HPLString::chrToStr(
			" %s:UE[h",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::J).c_str()));
		lst.push_back(HPLString::chrToStr(
			" %s:Zbg",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::K).c_str()));
/*		lst.push_back(HPLString::chrToStr(
			" %s,%s:EύX",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::LEFT).c_str(),
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::RIGHT).c_str()
			));
		lst.push_back(HPLString::chrToStr(
			" %s,%s:Aj[V؂ւ",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::UP).c_str(),
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::DOWN).c_str()
			));
		lst.push_back(HPLString::chrToStr(
			" %s:Aj[V",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::A).c_str()));*/
		/*
		lst.push_back(HPLString::chrToStr(
			" %s:UiςłႠIj",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::A).c_str()));
		lst.push_back(HPLString::chrToStr(
			" %s:Wv",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::B).c_str()));
		lst.push_back(HPLString::chrToStr(
			" %s,%s:@^Cv؂ւ",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::C).c_str(),
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::D).c_str()
			));
		lst.push_back(HPLString::chrToStr(
			" %s:ЂeXg",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::E).c_str()
			));
		lst.push_back(HPLString::chrToStr(
			" %s:MAXŏ㋉@",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::F).c_str()
			));
		lst.push_back(HPLString::chrToStr(
			" %s:LN^ւ",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::G).c_str()
			));
		lst.push_back(HPLString::chrToStr(
			" %s:Zbg",
			staticData->getInputManager()->getStringFromMyKey(GEnum::KeyMap::K).c_str()
			));
*/

		for(std::list<std::string>::iterator it = lst.begin(); it != lst.end(); it ++){
			sdlkanji->drawString(staticData->getGraphics()->getScreen(),
				left, top, fontID, r,g,b,
				it->c_str());
			top += INTERVAL_Y;
		}
	}
	// FKL[SDLK_eŃ}bvēǂݍ
	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::K)){
		staticData->startFadeOut(-1, 0);
	}

/*	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::LEFT)){
		player->setFaceDirection(FaceDirection::LEFT);
	}
	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::RIGHT)){
		player->setFaceDirection(FaceDirection::RIGHT);
	}
	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::UP)){
		int seqID = player->getSequenceID();
		seqID --;
		if(seqID < 0){
			seqID = GEnum::Udonge::MAX_AVAILABLE - 1;
		}
		player->setSequenceID(seqID);
	}
	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::DOWN)){
		int seqID = player->getSequenceID();
		seqID ++;
		if(seqID >= GEnum::Udonge::MAX_AVAILABLE){
			seqID = 0;
		}
		player->setSequenceID(seqID);
	}
	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::A)){
		HPLSequence* seq = player->getSequence();
		seq->resetCounter();
	}*/
/*
	//////
	// FGL[SDLK_dŃvC[ޕύX
	if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::G)){
		if(player->getType() == PlayerType::Undelsen){
			player->setType(PlayerType::Durandana);
		}else if(player->getType() == PlayerType::Durandana){
			player->setType(PlayerType::Undelsen);
		}
	}


	////
	// j[L[
	if(staticData->getSceneManager()->getSceneType() == GEnum::SceneType::Game){
		if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::E)){
			staticData->getGame()->setMenu(staticData->getGame()->isMenu());
			if(staticData->getGame()->isMenu() == true){
				menuSelect = 0;
			}
		}
	}

	//////
	// Cxg̎sƕ\
	staticData->checkEvent();


	if(staticData->getGame()->isMenu()){
		////
		// Ó]\
		HPLSequence* seq = staticData->getSequence(GEnum::SpriteType::Common,
			GEnum::Common::FadeOut);
		// TODO draw
		HPLSDLImageTool::blitRotozoomSpriteLeftTop(
			0, 0,
			0,
			seq,
			staticData->getImageManager(),
			staticData->getGraphics()->getScreen(),
			200);


		////
		// ^Cg\
		{
			float TITLE_TOP = 10;

			seq = staticData->getSequence(GEnum::SpriteType::Common,
				GEnum::Common::Title);
			float w = seq->getImageInformation(0)->srcRect.getWidth();
			float windowW = staticData->getSetting()->windowWidth;
			float left = windowW / 2 - w / 2;
			float top = TITLE_TOP;
		}

		////
		// j[\
		std::vector<std::string> lst;
		lst.push_back(std::string(""));
		lst.push_back(std::string("^Cg"));

		float TOP = 100;
		float LEFT = 200;
		float INTERVAL_Y = 20;

		for(int i = 0; i < lst.size(); i ++){
			float top = TOP + INTERVAL_Y * i;
		}

		/////
		// J[\\
		
		/////
		// L[
		if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::UP)){
			menuSelect --;
			if(menuSelect < 0){
				menuSelect = lst.size() - 1;
			}
		}
		if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::UP)){
			menuSelect ++;
			if(menuSelect >= lst.size()){
				menuSelect = 0;
			}
		}
		if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::A)){
		}
		if(staticData->getInputManager()->isPressedNow(GEnum::KeyMap::B)){
			////
			// LZ
			staticData->getGame()->setMenu(false);
		}
	}*/

/*	if(staticData->getGame()->isScenario()){
	}*/


/*	//////
	// Fscore\
	int fontID = 0;
	int r = 255, g = 255, b = 0;
	
	sdlkanji->drawString(staticData->getGraphics()->getScreen(),
		32, 5, fontID, r,g,b,
		"SCORE:%d (eXgF㉺L[Œ)", (int)staticData->getGame()->getScore());

	////
	// FL[Œ
	if(staticData->getInputManager()->isPressed(EGEnum::KeyMap::UP)){
		staticData->getGame()->addScore(0.5);
	}
	if(staticData->getInputManager()->isPressed(EGEnum::KeyMap::DOWN)){
		staticData->getGame()->addScore(-0.5);
	}

*/
}

